=== debian/changelog ===
firebuild (0.8.5-1) unstable; urgency=medium

  * New upstream release
    - Fix flaky clone() test (Closes: #1115384)
  * debian: Fix bash rebuild autopkgtest.
    The ./configure and make flags should be identical to the packaged bash build
    to use distro-specific settings. (LP: #2120853)
  * Drop backported patches
  * Suggest the out-of-archive qemu-user-interposable package
  * debian/control: Depend on libelf-dev

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 16 Nov 2025 21:27:44 +0100
