=== debian/changelog ===
firebuild (0.8.5.1-1) unstable; urgency=medium

  * debian/changelog: Rewrote too long line
  * New upstream release

 -- Balint Reczey <balint@balintreczey.hu>  Wed, 19 Nov 2025 22:07:34 +0100
