=== debian/changelog ===
firebuild (0.8.6-1) unstable; urgency=medium

  * New upstream release
    - Support zstd cache compression
  * Build-depend on libzstd-dev

 -- Balint Reczey <balint@balintreczey.hu>  Tue, 10 Feb 2026 12:45:28 +0100
