=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                libjemalloc-dev,
                libtsl-hopscotch-map-dev,
                libxxhash-dev (>= 0.8),
+               libzstd-dev,
                moreutils,
                po-debconf,
                python3-jinja2,
