## firebuild 0.8.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 if (NOT DEFINED FIREBUILD_VERSION)
   # Set in tagged commits only
-  set(FIREBUILD_VERSION "0.8.6")
+  set(FIREBUILD_VERSION "0.8.6.1")
 endif()
 
 if (NOT DEFINED FIREBUILD_VERSION)
