=== src/interceptor/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,7 @@
 set_source_files_properties(
   env.c
   ic_file_ops.c
+  time64_cast.c
   PROPERTIES COMPILE_FLAGS "${FAT_ARCH_C_FLAGS}")
 
 add_library(firebuild SHARED
@@ -65,6 +66,7 @@
   ic_file_ops.c
   intercept.c
   interceptors.c
+  time64_cast.c
   $<TARGET_OBJECTS:common_objs>
   $<TARGET_OBJECTS:fbbcomm_c>)
