=== debian/changelog ===
firebuild (0.8.6.1-1) unstable; urgency=medium

  * New upstream bugfix release
    - supervisor: Clear cache when it is in an old format
    - supervisor: Don't run GC in no-fetch or no-store modes.
      Also don't update cache metadata in read-only mode.

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 01 Mar 2026 23:30:11 +0100
